-- Time-stamp: <Sat Jan 24 1998 01:26:18 Stardate: [-30]0600.29 hwloidl>
--
-- Test wrapper for Barnes-Hut algorithm. See `Barnes-Hut.hs' for documentation
-----------------------------------------------------------------------------

--@node top, Main Module, (dir), (dir)
--@top

--@menu
--* Main Module::		
--@end menu

--@node Main Module,  , top, top
--@chapter Main Module

module Main where

--@menu
--* Imports::			
--* Main::			
--@end menu

--@node Imports, Main, Main Module, Main Module
--@section Imports

-- --@include Strategies
import Strategies
--@include BarnesHut
import BarnesHut

import Numeric (readDec)
import System (getArgs)


-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
--@node Main,  , Imports, Main Module
--@section Main

#if !defined(PRINT)
machmoH :: [Particle] -> Float
machmoH = foldr (\ ([x,y],[xd,yd],m) q -> q + x + y + xd + yd + m) 0.0
#endif

args_to_IntList a = map (\ a1 -> fst ((readDec a1) !! 0)) a

main = getArgs >>= \args ->
       let
         [sz,i] = (args_to_IntList args)
	 x = case sz of
               1 ->  [([1.0,2.0],[1.0,0.0],12.0)]
               2 ->  [([1.0,2.0],[1.0,0.0],12.0),
                      ([7.0,3.0],[0.0,1.0],4.0)]       
               3 ->  [([1.0,2.0],[1.0,0.0],12.0),
                      ([7.0,3.0],[0.0,1.0],4.0),       
                      ([0.0,3.0],[1.0,1.0],7.0)]
               4 ->  [([1.0,2.0],[1.0,0.0],12.0),
                      ([7.0,3.0],[0.0,1.0],4.0),       
                      ([0.0,3.0],[1.0,1.0],7.0),       
                      ([2.0,1.0],[2.0,1.0],11.0)]
               5 -> [([0.0,0.0],[0.0,0.0], 1.0),
                     ([2.0,0.0],[1.0,0.0], 2.0),
                     ([0.0,2.0],[0.0,1.0], 2.0),
                     ([-2.0,0.0],[-1.0,0.0], 2.0),
                     ([0.0,-2.0],[0.0,-1.0], 2.0)]
               6 -> [([0.0,0.0],[0.0,0.0], 1.0),
                     ([2.0,0.0],[1.0,0.0], 2.0),
                     ([0.0,2.0],[0.0,1.0], 2.0),
                     ([-2.0,0.0],[-1.0,0.0], 2.0),
                     ([0.0,-2.0],[0.0,-1.0], 2.0),
                     ([1.0,1.0], [0.0,0.0], 1.0)]
               7 -> [([0.0,0.0],[0.0,0.0], 1.0),
                     ([2.0,0.0],[1.0,0.0], 2.0),
                     ([0.0,2.0],[0.0,1.0], 2.0),
                     ([-2.0,0.0],[-1.0,0.0], 2.0),
                     ([0.0,-2.0],[0.0,-1.0], 2.0),
                     ([1.0,1.0], [0.0,0.0], 1.0),
                     ([-1.0,-1.0], [0.0,0.0], 1.0)]
               8 -> [([2.0,0.0],[1.0,0.0], 2.0),
                     ([0.0,2.0],[0.0,1.0], 2.0),
                     ([-2.0,0.0],[-1.0,0.0], 2.0),
                     ([0.0,-2.0],[0.0,-1.0], 2.0),
                     ([2.0,2.0],[1.0,1.0], 2.0),
                     ([-2.0,2.0],[-1.0,1.0], 2.0),
                     ([2.0,-2.0],[1.0,-1.0], 2.0),
                     ([-2.0,-2.0],[-1.0,-1.0], 2.0)]
               9 -> [([0.0,0.0],[0.0,0.0], 1.0),
                     ([2.0,0.0],[1.0,0.0], 2.0),
                     ([0.0,2.0],[0.0,1.0], 2.0),
                     ([-2.0,0.0],[-1.0,0.0], 2.0),
                     ([0.0,-2.0],[0.0,-1.0], 2.0),
                     ([2.0,2.0],[1.0,1.0], 2.0),
                     ([2.0,-2.0],[1.0,-1.0], 2.0),
                     ([-2.0,2.0],[-1.0,1.0], 2.0),
                     ([-2.0,-2.0],[-1.0,-1.0], 2.0)]
               12 -> [([1.0, 0.0], [0.0, 1.0], 1.0),
                     ([2.0, 0.0], [0.0, 1.0], 1.0),
                     ([3.0, 0.0], [0.0, 1.0], 1.0),
                     ([4.0, 0.0], [0.0, 1.0], 1.0),
                     ([5.0, 0.0], [0.0, 1.0], 1.0),
                     ([6.0, 0.0], [0.0, 1.0], 1.0),
                     ([7.0, 0.0], [0.0, 1.0], 1.0),
                     ([8.0, 0.0], [0.0, 1.0], 1.0),
                     ([9.0, 0.0], [0.0, 1.0], 1.0),
                     ([10.0, 0.0], [0.0, 1.0], 1.0),
                     ([11.0, 0.0], [0.0, 1.0], 1.0),
                     ([12.0, 0.0], [0.0, 1.0], 1.0)]

	       {-
	       5 ->  [([3.0,1.0],[2.0,0.0],4.0),
	              ([9.0,3.0],[-1.0,0.0],3.0),
		      ([6.0,0.0],[1.0,1.0],9.0),
		      ([-2.0,1.0],[0.0,0.0],5.0),
		      ([24.0,1.0],[9.0,1.0],33.0)]
               5 ->  [([1.0,2.0],[1.0,0.0],12.0),
                      ([7.0,3.0],[0.0,1.0],4.0),       
                      ([0.0,3.0],[1.0,1.0],7.0),       
                      ([2.0,1.0],[2.0,1.0],11.0),       
                      ([-1.0,3.0],[0.0,-1.0],2.0)]
               -}
	 res = (iterate iteration x) !! i
       in
#ifdef PRINT
        putStrLn ("Input :: [Particle] = \n" ++ (show x)) >>
        putStrLn ("Iterations = " ++ (show i)) >>
        putStrLn ("Output :: [Particle] = \n" ++ (show res))
#else
        putStrLn ("Done " ++ (show (machmoH res)))
#endif

